#ifndef _FFT_H
#define _FFT_H

#include <stdlib.h>
#include <complex.h>
#include "svector.h"

class WrongNumberOfPoints{} ;

inline double abs( double vl )
{
	return fabs( vl ) ;
} ;

inline double round ( double vl )
{
	return (vl-floor(vl)) < 0.5 ? floor(vl) : ceil(vl) ;
} ;

class Fft
{
public:
	Fft( int Points ) ;
	~Fft() {} ;
	int Points () const { return _Points ; } ;

	svector<complex>& Transform( svector<complex>& ) ;
	svector<double>& 	Transform( svector<double>& ) ; //, bool = false ) ;
//	svector<int>&		Transform( svector<int>&, bool = false ) ;	// Arquivos WAVE de 16 bits
//	svector<char>& 	Transform( svector<char>&, bool = false ) ;	// Arquivos WAVE de 8 bits

protected:
	void _Transform() ;
	int _Points ;
	const double pi ;

private :
	int _logPoints ;
	double _sqrtPoints ;
	svector<int> _aBitRev ;
	svector< svector< complex > > _W ;
	svector<complex> x ;

	svector<double> vec_char ;	// Devido a um bug do compilador ao trabalhar
} ;									// com Templates de classes sem nenhum objeto criado

#endif

